from sys import argv
from moteur_chainage_arriere.connaissance import BaseConnaissances
from moteur_chainage_arriere.chainage_arriere import ChainageArriere
from moteur_avec_variables.regle_avec_variables import RegleAvecVariables
from moteur_avec_variables.unificateur import Unificateur

faits = [('r', 'd')]
regles = [[[('r', '?a')], ('q', '?b')], [[('q', '?b')], ('r', '?a')]]
questions = [('r', '?qui')]

bc = BaseConnaissances(lambda descr: RegleAvecVariables(descr[0], descr[1]))
bc.ajoute_faits(faits)
bc.ajoute_regles(regles)

moteur = ChainageArriere(bc, Unificateur())

for question in questions:

    print()
    print('Question: ' + str(question))

    moteur.reinitialise()
    moteur.chaine(question)

    moteur.affiche_solutions()

    if len(argv) > 1 and argv[1].lower() == 'trace':
        moteur.affiche_trace()